<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/system_library_auth_maint/include/lalr_grammar_semantics_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.Macro { color: #00afaf; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.Number { color: #ff5faf; }
.Conditional { color: #af87d7; font-weight: bold; }
.Function { color: #d0d0d0; }
.pliRainbow_lv1_p0 { color: #ffffe0; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Comment { color: #808080; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="Normal">lalr_grammar_semantics_</span><span class="Operator">:</span> <span class="Keyword">proc</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">prod_no</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span><span class="Comment">/*        SEMANTICS SEGMENT lalr_grammar_semantics_.incl.pl1</span>
<span id="L4" class="LineNr">  4 </span><span class="Comment">          Generated by: Swenson.SysAdmin.a using LALR 7.3a of Thursday, January 24, 1985</span>
<span id="L5" class="LineNr">  5 </span><span class="Comment">          Generated at: Gold Hill Multics</span>
<span id="L6" class="LineNr">  6 </span><span class="Comment">          Generated on: 08/07/22  0955.7 pdt Sun</span>
<span id="L7" class="LineNr">  7 </span><span class="Comment">          Generated from: &gt;udd&gt;sa&gt;ejs&gt;work&gt;temp&gt;mit&gt;foo&gt;lalr_parse_grammar_.lalr</span>
<span id="L8" class="LineNr">  8 </span><span class="Comment">*/</span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span><span class="Keyword">dcl</span>  <span class="Normal">prod_no</span> <span class="Macro">fixed</span> <span class="Macro">bin</span> <span class="Macro">parameter</span><span class="Normal">;</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>          <span class="Keyword">go</span> <span class="Keyword">to</span> <span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">prod_no</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span><span class="Comment">/* -order '::=</span>
<span id="L15" class="LineNr"> 15 </span><span class="Comment">          '|</span>
<span id="L16" class="LineNr"> 16 </span><span class="Comment">          &lt;non-terminal symbol&gt;</span>
<span id="L17" class="LineNr"> 17 </span><span class="Comment">          &lt;rule semantics&gt;</span>
<span id="L18" class="LineNr"> 18 </span><span class="Comment">          &lt;production semantics&gt;</span>
<span id="L19" class="LineNr"> 19 </span><span class="Comment">          &lt;terminal symbol&gt;</span>
<span id="L20" class="LineNr"> 20 </span><span class="Comment">-sem lalr_grammar_semantics_.incl.pl1</span>
<span id="L21" class="LineNr"> 21 </span><span class="Comment">-optimize</span>
<span id="L22" class="LineNr"> 22 </span><span class="Comment">-table lalr_parse_grammar_t_</span>
<span id="L23" class="LineNr"> 23 </span><span class="Comment">-terminals_list</span>
<span id="L24" class="LineNr"> 24 </span><span class="Comment">-production_names</span>
<span id="L25" class="LineNr"> 25 </span><span class="Comment">-production</span>
<span id="L26" class="LineNr"> 26 </span><span class="Comment">-no_terminals_hash_list (* Added:  01 May 85 - B. Wong *)</span>
<span id="L27" class="LineNr"> 27 </span><span class="Comment">-no_synonyms            (* Added:  01 May 85 - B. Wong *)</span>
<span id="L28" class="LineNr"> 28 </span><span class="Comment">-parse */</span>
<span id="L29" class="LineNr"> 29 </span><span class="Keyword">dcl</span> <span class="Normal">i</span> <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">;</span>
<span id="L30" class="LineNr"> 30 </span><span class="Keyword">dcl</span>  <span class="Function">unspec</span> <span class="Macro">builtin</span><span class="Normal">;</span>
<span id="L31" class="LineNr"> 31 </span><span class="Comment">/* &lt;lalr&gt; ::=</span>
<span id="L32" class="LineNr"> 32 </span><span class="Comment">          &lt;rules&gt;! */</span>
<span id="L33" class="LineNr"> 33 </span><span class="Comment">/* &lt;rules&gt; ::=</span>
<span id="L34" class="LineNr"> 34 </span><span class="Comment">          &lt;rule&gt; |</span>
<span id="L35" class="LineNr"> 35 </span><span class="Comment">          &lt;rules&gt; &lt;rule&gt;! */</span>
<span id="L36" class="LineNr"> 36 </span><span class="Comment">/* &lt;rule&gt; ::=</span>
<span id="L37" class="LineNr"> 37 </span><span class="Comment">          &lt;production name&gt; &lt;::=&gt; &lt;alternatives&gt; &lt;rule semantics&gt;! */</span>
<span id="L38" class="LineNr"> 38 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">4</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L39" class="LineNr"> 39 </span>          <span class="Conditional">if</span> <span class="Operator">^</span><span class="Normal">prod_sw</span>
<span id="L40" class="LineNr"> 40 </span>          <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L41" class="LineNr"> 41 </span>               <span class="Conditional">if</span> <span class="Normal">separate_semantics_sw</span> <span class="Operator">&amp;</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv1_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv1_p0">)</span> <span class="Operator">^=</span> <span class="Number">0</span> | <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">tag</span> <span class="pliRainbow_lv1_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv1_p0">)</span> <span class="Operator">^=</span> <span class="Number">0</span><span class="pliRainbow_lv0_p0">)</span>
<span id="L42" class="LineNr"> 42 </span>               <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L43" class="LineNr"> 43 </span>                    <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Keyword">procedure</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L44" class="LineNr"> 44 </span>                    <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Keyword">entry</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L45" class="LineNr"> 45 </span>                    <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Normal">tag</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">tag</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L46" class="LineNr"> 46 </span>                    <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L47" class="LineNr"> 47 </span>                    <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L48" class="LineNr"> 48 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L49" class="LineNr"> 49 </span>               <span class="Conditional">if</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">^=</span> <span class="Number">0</span>
<span id="L50" class="LineNr"> 50 </span>               <span class="Keyword">then</span> <span class="Keyword">do</span> <span class="Normal">i</span> <span class="Operator">=</span> <span class="Normal">first_production_index</span> <span class="Keyword">to</span> <span class="Normal">productions_list_size</span><span class="Normal">;</span>
<span id="L51" class="LineNr"> 51 </span>                    <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">rule</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">i</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">rule_num</span><span class="Normal">;</span>
<span id="L52" class="LineNr"> 52 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L53" class="LineNr"> 53 </span>          <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L54" class="LineNr"> 54 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L55" class="LineNr"> 55 </span><span class="Comment">/* &lt;alternatives&gt; ::=</span>
<span id="L56" class="LineNr"> 56 </span><span class="Comment">          &lt;production&gt; |</span>
<span id="L57" class="LineNr"> 57 </span><span class="Comment">          &lt;alternatives&gt; &lt;|&gt; &lt;production&gt;! */</span>
<span id="L58" class="LineNr"> 58 </span><span class="Comment">/* &lt;production&gt; ::=</span>
<span id="L59" class="LineNr"> 59 </span><span class="Comment">          |</span>
<span id="L60" class="LineNr"> 60 </span><span class="Comment">          &lt;production semantics&gt; |</span>
<span id="L61" class="LineNr"> 61 </span><span class="Comment">          &lt;symbols&gt; |</span>
<span id="L62" class="LineNr"> 62 </span><span class="Comment">          &lt;symbols&gt; &lt;production semantics&gt;! */</span>
<span id="L63" class="LineNr"> 63 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">8</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L64" class="LineNr"> 64 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">10</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L65" class="LineNr"> 65 </span>          <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Keyword">procedure</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L66" class="LineNr"> 66 </span>          <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Keyword">entry</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L67" class="LineNr"> 67 </span>          <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Normal">tag</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">tag</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L68" class="LineNr"> 68 </span>          <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L69" class="LineNr"> 69 </span>          <span class="Normal">actions_list</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L70" class="LineNr"> 70 </span>          <span class="Conditional">if</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">^=</span> <span class="Number">0</span> <span class="Keyword">then</span>
<span id="L71" class="LineNr"> 71 </span>               <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">rule</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">rule_num</span><span class="Normal">;</span>
<span id="L72" class="LineNr"> 72 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L73" class="LineNr"> 73 </span><span class="Comment">/* &lt;symbols&gt; ::=</span>
<span id="L74" class="LineNr"> 74 </span><span class="Comment">          &lt;symbol&gt; |</span>
<span id="L75" class="LineNr"> 75 </span><span class="Comment">          &lt;symbols&gt; &lt;symbol&gt;! */</span>
<span id="L76" class="LineNr"> 76 </span><span class="Comment">/* &lt;symbol&gt; ::=</span>
<span id="L77" class="LineNr"> 77 </span><span class="Comment">          &lt;non-terminal symbol&gt; |</span>
<span id="L78" class="LineNr"> 78 </span><span class="Comment">          &lt;terminal symbol&gt;! */</span>
<span id="L79" class="LineNr"> 79 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">13</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L80" class="LineNr"> 80 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">14</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L81" class="LineNr"> 81 </span>          <span class="Keyword">call</span> <span class="Normal">store</span><span class="Normal">;</span>
<span id="L82" class="LineNr"> 82 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L83" class="LineNr"> 83 </span><span class="Comment">/* &lt;production name&gt; ::=</span>
<span id="L84" class="LineNr"> 84 </span><span class="Comment">          &lt;non-terminal symbol&gt;! */</span>
<span id="L85" class="LineNr"> 85 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">15</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L86" class="LineNr"> 86 </span>          <span class="Keyword">call</span> <span class="Normal">store</span><span class="Normal">;</span>
<span id="L87" class="LineNr"> 87 </span>          <span class="Normal">fsl</span> <span class="Operator">=</span> <span class="Normal">symbols_list_size</span><span class="Normal">;</span>
<span id="L88" class="LineNr"> 88 </span>          <span class="Normal">production_name_last_applied</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">1</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L89" class="LineNr"> 89 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L90" class="LineNr"> 90 </span><span class="Comment">/* &lt;::=&gt; ::=</span>
<span id="L91" class="LineNr"> 91 </span><span class="Comment">          '::=! */</span>
<span id="L92" class="LineNr"> 92 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">16</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L93" class="LineNr"> 93 </span>          <span class="Normal">Alt</span> <span class="Operator">=</span> <span class="Number">1</span><span class="Normal">;</span>
<span id="L94" class="LineNr"> 94 </span>          <span class="Conditional">if</span> <span class="Normal">separate_semantics_sw</span>
<span id="L95" class="LineNr"> 95 </span>          <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L96" class="LineNr"> 96 </span>               <span class="Normal">actions_list_size</span> <span class="Operator">=</span> <span class="Normal">actions_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L97" class="LineNr"> 97 </span>               <span class="Function">unspec</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list</span> <span class="pliRainbow_lv1_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Operator">&quot;&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L98" class="LineNr"> 98 </span>          <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L99" class="LineNr"> 99 </span>          <span class="Normal">first_production_index</span><span class="Normal">,</span> <span class="Normal">productions_list_size</span> <span class="Operator">=</span> <span class="Normal">productions_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L100" class="LineNr">100 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">first_symbol</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">symbols_list_size</span><span class="Normal">;</span>
<span id="L101" class="LineNr">101 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">rule</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Operator">-</span><span class="Normal">rule_num</span><span class="Normal">;</span>
<span id="L102" class="LineNr">102 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">alternative</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">Alt</span><span class="Normal">;</span>
<span id="L103" class="LineNr">103 </span>          <span class="Normal">production_name_last_applied</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">0</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L104" class="LineNr">104 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L105" class="LineNr">105 </span><span class="Comment">/* &lt;|&gt; ::=</span>
<span id="L106" class="LineNr">106 </span><span class="Comment">          '|! */</span>
<span id="L107" class="LineNr">107 </span><span class="Function">prod</span> <span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span><span class="Operator">:</span>
<span id="L108" class="LineNr">108 </span>          <span class="Conditional">if</span> <span class="Normal">separate_semantics_sw</span> <span class="Operator">&amp;</span> <span class="Normal">prod_sw</span>
<span id="L109" class="LineNr">109 </span>          <span class="Keyword">then</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L110" class="LineNr">110 </span>               <span class="Normal">actions_list_size</span> <span class="Operator">=</span> <span class="Normal">actions_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L111" class="LineNr">111 </span>               <span class="Function">unspec</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">actions_list</span> <span class="pliRainbow_lv1_p0">(</span><span class="Normal">actions_list_size</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Operator">&quot;&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L112" class="LineNr">112 </span>          <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L113" class="LineNr">113 </span>          <span class="Normal">symbols_list_size</span> <span class="Operator">=</span> <span class="Normal">symbols_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L114" class="LineNr">114 </span>                                                            <span class="Comment">/* This symbol number aliases the original. */</span>
<span id="L115" class="LineNr">115 </span>          <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Macro">position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Macro">position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">fsl</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L116" class="LineNr">116 </span>          <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Function">length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Function">length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">fsl</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L117" class="LineNr">117 </span>          <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L118" class="LineNr">118 </span>          <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L119" class="LineNr">119 </span>          <span class="Normal">productions_list_size</span> <span class="Operator">=</span> <span class="Normal">productions_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L120" class="LineNr">120 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">first_symbol</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">symbols_list_size</span><span class="Normal">;</span>
<span id="L121" class="LineNr">121 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">rule</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Operator">-</span><span class="Normal">rule_num</span><span class="Normal">;</span>
<span id="L122" class="LineNr">122 </span>          <span class="Normal">productions_list</span><span class="Normal">.</span><span class="Normal">alternative</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">productions_list_size</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span> <span class="Normal">Alt</span> <span class="Operator">=</span> <span class="Normal">Alt</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>
<span id="L123" class="LineNr">123 </span>          <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span><span class="Normal">store</span><span class="Operator">:</span>    <span class="Keyword">proc</span><span class="Normal">;</span>
<span id="L126" class="LineNr">126 </span>               <span class="Normal">symbols_list_size</span> <span class="Operator">=</span> <span class="Normal">symbols_list_size</span><span class="Operator">+</span><span class="Number">1</span><span class="Normal">;</span>     <span class="Comment">/* Store the current symbol in &quot;symbols_list&quot;. */</span>
<span id="L127" class="LineNr">127 </span>               <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Macro">position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_position</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L128" class="LineNr">128 </span>               <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Function">length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Normal">token_length</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L129" class="LineNr">129 </span>               <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Macro">file</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L130" class="LineNr">130 </span>               <span class="Normal">unclassified_symbols_list</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">symbols_list_size</span><span class="pliRainbow_lv0_p0">)</span> <span class="Operator">=</span> <span class="Normal">stk</span><span class="Normal">.</span><span class="Function">line</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">stk_top</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L131" class="LineNr">131 </span>               <span class="Keyword">return</span><span class="Normal">;</span>
<span id="L132" class="LineNr">132 </span>          <span class="Keyword">end</span> <span class="Normal">store</span><span class="Normal">;</span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span><span class="Keyword">end</span> <span class="Normal">lalr_grammar_semantics_</span><span class="Normal">;</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
